VTK: vtkStructuredGrid Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkStructuredGrid Class Reference

topologically regular array of data More...

`#include <vtkStructuredGrid.h>`

Inheritance diagram for vtkStructuredGrid:
[legend]
Collaboration diagram for vtkStructuredGrid:
[legend]

## Public Types
typedef vtkPointSet | Superclass
Public Types inherited from vtkPointSet
typedef vtkDataSet | Superclass
| Standard methods for type information and printing. More...
Public Types inherited from vtkDataSet
enum | FieldDataType { DATA_OBJECT_FIELD = 0 , POINT_DATA_FIELD = 1 , CELL_DATA_FIELD = 2 }
typedef vtkDataObject | Superclass
Public Types inherited from vtkDataObject
enum | FieldAssociations { FIELD_ASSOCIATION_POINTS , FIELD_ASSOCIATION_CELLS , FIELD_ASSOCIATION_NONE , FIELD_ASSOCIATION_POINTS_THEN_CELLS , FIELD_ASSOCIATION_VERTICES , FIELD_ASSOCIATION_EDGES , FIELD_ASSOCIATION_ROWS , NUMBER_OF_ASSOCIATIONS }
| Possible values for the FIELD_ASSOCIATION information entry. More...
enum | AttributeTypes { POINT , CELL , FIELD , POINT_THEN_CELL , VERTEX , EDGE , ROW , NUMBER_OF_ATTRIBUTE_TYPES }
| Possible attribute types. More...
enum | FieldOperations { FIELD_OPERATION_PRESERVED , FIELD_OPERATION_REINTERPOLATED , FIELD_OPERATION_MODIFIED , FIELD_OPERATION_REMOVED }
| Possible values for the FIELD_OPERATION information entry. More...
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for type information and printing. More...
vtkStructuredGrid * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for type information and printing. More...
int | GetDataObjectType () override
| Return what type of dataset this is. More...
void | CopyStructure (vtkDataSet *ds) override
| Copy the geometric and topological structure of an input poly data object. More...
int | GetDataDimension ()
| Return the dimensionality of the data. More...
unsigned long | GetActualMemorySize () override
| Return the actual size of the data in kibibytes (1024 bytes). More...
int | GetExtentType () override
| The extent type is a 3D extent. More...
unsigned char | IsPointVisible (vtkIdType ptId)
| Return non-zero value if specified point is visible. More...
unsigned char | IsCellVisible (vtkIdType cellId)
| Return non-zero value if specified point is visible. More...
bool | HasAnyBlankPoints () override
| Returns 1 if there is any visibility constraint on the points, 0 otherwise. More...
bool | HasAnyBlankCells () override
| Returns 1 if there is any visibility constraint on the cells, 0 otherwise. More...
void | GetCellDims (int cellDims[3])
| Given the node dimensions of this grid instance, this method computes the node dimensions. More...
void | Crop (const int *updateExtent) override
| Reallocates and copies to set the Extent to the UpdateExtent. More...
void | GetPoint (int i, int j, int k, double p[3], bool adjustForExtent=true)
| Get a point in the grid. More...
vtkIdType | GetNumberOfPoints () override
| Standard vtkDataSet API methods. More...
double * | GetPoint (vtkIdType ptId) override
| Standard vtkDataSet API methods. More...
void | GetPoint (vtkIdType ptId, double p[3]) override
| Standard vtkDataSet API methods. More...
vtkCell * | GetCell (vtkIdType cellId) override
| Standard vtkDataSet API methods. More...
vtkCell * | GetCell (int i, int j, int k) override
| Standard vtkDataSet API methods. More...
void | GetCell (vtkIdType cellId, vtkGenericCell *cell) override
| Standard vtkDataSet API methods. More...
void | GetCellBounds (vtkIdType cellId, double bounds[6]) override
| Standard vtkDataSet API methods. More...
int | GetCellType (vtkIdType cellId) override
| Standard vtkDataSet API methods. More...
vtkIdType | GetCellSize (vtkIdType cellId) override
| Standard vtkDataSet API methods. More...
vtkIdType | GetNumberOfCells () override
| Standard vtkDataSet API methods. More...
void | GetCellPoints (vtkIdType cellId, vtkIdList *ptIds) override
| Standard vtkDataSet API methods. More...
void | GetPointCells (vtkIdType ptId, vtkIdList *cellIds) override
| Standard vtkDataSet API methods. More...
void | Initialize () override
| Standard vtkDataSet API methods. More...
int | GetMaxCellSize () override
| Standard vtkDataSet API methods. More...
void | GetCellNeighbors (vtkIdType cellId, vtkIdList *ptIds, vtkIdList *cellIds) override
| Standard vtkDataSet API methods. More...
void | GetCellNeighbors (vtkIdType cellId, vtkIdList *ptIds, vtkIdList *cellIds, int *seedLoc)
| Standard vtkDataSet API methods. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdList *ptIds)=0
| Topological inquiry to get points defining cell. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdType &npts, vtkIdType const *&pts, vtkIdList *ptIds)
| Topological inquiry to get points defining cell. More...
void | SetDimensions (int i, int j, int k)
| Sets the extent to be 0 to i-1, 0 to j-1, and 0 to k-1. More...
void | SetDimensions (const int dims[3])
| Sets the extent to be 0 to dim[i]-1 in all 3 dimensions. More...
virtual int * | GetDimensions ()
| Get dimensions of this structured grid. More...
virtual void | GetDimensions (int dims[3])
| Get dimensions of this structured grid based on its extent. More...
void | SetExtent (VTK_FUTURE_CONST int extent[6])
| Different ways to set the extent of the data array. More...
void | SetExtent (int xMin, int xMax, int yMin, int yMax, int zMin, int zMax)
| Different ways to set the extent of the data array. More...
virtual int * | GetExtent ()
| Different ways to set the extent of the data array. More...
virtual void | GetExtent (int &, int &, int &, int &, int &, int &)
| Different ways to set the extent of the data array. More...
virtual void | GetExtent (int[6])
| Different ways to set the extent of the data array. More...
void | ShallowCopy (vtkDataObject *src) override
| Shallow and Deep copy. More...
void | DeepCopy (vtkDataObject *src) override
| Shallow and Deep copy. More...
void | BlankPoint (vtkIdType ptId)
| Methods for supporting blanking of cells. More...
void | UnBlankPoint (vtkIdType ptId)
| Methods for supporting blanking of cells. More...
void | BlankCell (vtkIdType ptId)
| Methods for supporting blanking of cells. More...
void | UnBlankCell (vtkIdType ptId)
| Methods for supporting blanking of cells. More...
Public Member Functions inherited from vtkPointSet
vtkCellIterator * | NewCellIterator () override
| Return an iterator that traverses the cells in this data set. More...
void | BuildCellLocator ()
| Build the cell locator. More...
vtkMTimeType | GetMTime () override
| Get MTime which also considers its vtkPoints MTime. More...
void | ComputeBounds () override
| Compute the (X, Y, Z) bounds of the data. More...
void | Squeeze () override
| Reclaim any unused memory. More...
virtual void | SetEditable (bool)
| Specify whether this dataset is editable after creation. More...
virtual bool | GetEditable ()
| Specify whether this dataset is editable after creation. More...
virtual void | EditableOn ()
| Specify whether this dataset is editable after creation. More...
virtual void | EditableOff ()
| Specify whether this dataset is editable after creation. More...
vtkIdType | FindPoint (double x[3]) override
| See vtkDataSet for additional information. More...
vtkIdType | FindPoint (double x, double y, double z)
| See vtkDataSet for additional information. More...
vtkIdType | FindCell (double x[3], vtkCell *cell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights) override
| See vtkDataSet for additional information. More...
vtkIdType | FindCell (double x[3], vtkCell *cell, vtkGenericCell *gencell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights) override
| See vtkDataSet for additional information. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdList *ptIds)=0
| This method resets parameter idList, as there is no cell in a `vtkPointSet`. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdType &npts, vtkIdType const *&pts, vtkIdList *ptIds)
| This method resets parameter idList, as there is no cell in a `vtkPointSet`. More...
void | BuildPointLocator ()
| Build the internal point locator . More...
void | BuildLocator ()
| Build the internal point locator . More...
virtual void | SetPointLocator (vtkAbstractPointLocator *)
| Set / get an instance of vtkAbstractPointLocator which is used to support the FindPoint() and FindCell() methods. More...
virtual vtkAbstractPointLocator * | GetPointLocator ()
| Set / get an instance of vtkAbstractPointLocator which is used to support the FindPoint() and FindCell() methods. More...
virtual void | SetCellLocator (vtkAbstractCellLocator *)
| Set / get an instance of vtkAbstractCellLocator which may be used when a vtkCellLocatorStrategy is used during a FindCell() operation. More...
virtual vtkAbstractCellLocator * | GetCellLocator ()
| Set / get an instance of vtkAbstractCellLocator which may be used when a vtkCellLocatorStrategy is used during a FindCell() operation. More...
virtual void | SetPoints (vtkPoints *)
| Specify point array to define point coordinates. More...
virtual vtkPoints * | GetPoints ()
| Specify point array to define point coordinates. More...
bool | UsesGarbageCollector () const override
| Overwritten to handle the data/locator loop. More...
vtkPointSet * | NewInstance () const
| Standard methods for type information and printing. More...
Public Member Functions inherited from vtkDataSet
vtkDataSet * | NewInstance () const
virtual void | CopyAttributes (vtkDataSet *ds)
| Copy the attributes associated with the specified dataset to this instance of vtkDataSet. More...
virtual vtkCell * | GetCell (int vtkNotUsed(i), int vtkNotUsed(j), int vtkNotUsed(k))
void | SetCellOrderAndRationalWeights (vtkIdType cellId, vtkGenericCell *cell)
virtual void | GetCellTypes (vtkCellTypes *types)
| Get a list of types of cells in a dataset. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdType &npts, vtkIdType const *&pts, vtkIdList *ptIds)
| Topological inquiry to get points defining cell. More...
int | GetCellNumberOfFaces (vtkIdType cellId, unsigned char &cellType, vtkGenericCell *cell)
| Get the number of faces of a cell. More...
virtual vtkCell * | FindAndGetCell (double x[3], vtkCell *cell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights)
| Locate the cell that contains a point and return the cell. More...
vtkCellData * | GetCellData ()
| Return a pointer to this dataset's cell data. More...
vtkPointData * | GetPointData ()
| Return a pointer to this dataset's point data. More...
double * | GetBounds ()
| Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax). More...
void | GetBounds (double bounds[6])
| Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax). More...
double * | GetCenter ()
| Get the center of the bounding box. More...
void | GetCenter (double center[3])
| Get the center of the bounding box. More...
double | GetLength ()
| Return the length of the diagonal of the bounding box. More...
double | GetLength2 ()
| Return the squared length of the diagonal of the bounding box. More...
virtual void | GetScalarRange (double range[2])
| Convenience method to get the range of the first component (and only the first component) of any scalars in the data set. More...
double * | GetScalarRange ()
| Convenience method to get the range of the first component (and only the first component) of any scalars in the data set. More...
int | CheckAttributes ()
| This method checks to see if the cell and point attributes match the geometry. More...
vtkFieldData * | GetAttributesAsFieldData (int type) override
| Returns the attributes of the data object as a vtkFieldData. More...
vtkIdType | GetNumberOfElements (int type) override
| Get the number of elements for a specific attribute type (POINT, CELL, etc.). More...
bool | HasAnyGhostCells ()
| Returns 1 if there are any ghost cells 0 otherwise. More...
bool | HasAnyGhostPoints ()
| Returns 1 if there are any ghost points 0 otherwise. More...
vtkUnsignedCharArray * | GetPointGhostArray ()
| Gets the array that defines the ghost type of each point. More...
void | UpdatePointGhostArrayCache ()
| Updates the pointer to the point ghost array. More...
vtkUnsignedCharArray * | AllocatePointGhostArray ()
| Allocate ghost array for points. More...
vtkUnsignedCharArray * | GetCellGhostArray ()
| Get the array that defines the ghost type of each cell. More...
void | UpdateCellGhostArrayCache ()
| Updates the pointer to the cell ghost array. More...
vtkUnsignedCharArray * | AllocateCellGhostArray ()
| Allocate ghost array for cells. More...
vtkUnsignedCharArray * | GetGhostArray (int type) override
| Returns the ghost array for the given type (point or cell). More...
vtkIdType | FindPoint (double x, double y, double z)
| Locate the closest point to the global coordinate x. More...
virtual void | GenerateGhostArray (int zeroExt[6])
| Normally called by pipeline executives or algorithms only. More...
virtual void | GenerateGhostArray (int zeroExt[6], bool cellOnly)
| Normally called by pipeline executives or algorithms only. More...
Public Member Functions inherited from vtkDataObject
vtkDataObject * | NewInstance () const
void | ReleaseData ()
| Release data back to system to conserve memory resource. More...
vtkMTimeType | GetUpdateTime ()
| Used by Threaded ports to determine if they should initiate an asynchronous update (still in development). More...
virtual void | CopyInformationFromPipeline (vtkInformation *vtkNotUsed(info))
| Copy from the pipeline information to the data object's own information. More...
virtual void | CopyInformationToPipeline (vtkInformation *vtkNotUsed(info))
| Copy information from this data object to the pipeline information. More...
void | DataHasBeenGenerated ()
| This method is called by the source when it executes to generate data. More...
virtual void | PrepareForNewData ()
| make the output data ready for new data to be inserted. More...
virtual vtkDataSetAttributes * | GetAttributes (int type)
| Returns the attributes of the data object of the specified attribute type. More...
virtual int | GetAttributeTypeForArray (vtkAbstractArray *arr)
| Retrieves the attribute type that an array came from. More...
virtual vtkInformation * | GetInformation ()
| Set/Get the information object associated with this data object. More...
virtual void | SetInformation (vtkInformation *)
| Set/Get the information object associated with this data object. More...
virtual vtkTypeBool | GetDataReleased ()
| Get the flag indicating the data has been released. More...
virtual void | SetFieldData (vtkFieldData *)
| Assign or retrieve a general field data to this data object. More...
virtual vtkFieldData * | GetFieldData ()
| Assign or retrieve a general field data to this data object. More...
void | GlobalReleaseDataFlagOn ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
void | GlobalReleaseDataFlagOff ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...

## Static Public Member Functions
static vtkStructuredGrid * | New ()
static vtkStructuredGrid * | ExtendedNew ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkStructuredGrid * | SafeDownCast (vtkObjectBase *o)
static vtkStructuredGrid * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkStructuredGrid * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
Static Public Member Functions inherited from vtkPointSet
static vtkPointSet * | New ()
| Standard instantiation method. More...
static vtkPointSet * | ExtendedNew ()
static vtkPointSet * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkPointSet * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for type information and printing. More...
static vtkPointSet * | SafeDownCast (vtkObjectBase *o)
| Standard methods for type information and printing. More...
Static Public Member Functions inherited from vtkDataSet
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDataSet * | SafeDownCast (vtkObjectBase *o)
static vtkDataSet * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkDataSet * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
Static Public Member Functions inherited from vtkDataObject
static vtkDataObject * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDataObject * | SafeDownCast (vtkObjectBase *o)
static vtkInformation * | GetActiveFieldInformation (vtkInformation *info, int fieldAssociation, int attributeType)
| Return the information object within the input information object's field data corresponding to the specified association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS) and attribute (SCALARS, VECTORS, NORMALS, TCOORDS, or TENSORS) More...
static vtkInformation * | GetNamedFieldInformation (vtkInformation *info, int fieldAssociation, const char *name)
| Return the information object within the input information object's field data corresponding to the specified association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS) and name. More...
static void | RemoveNamedFieldInformation (vtkInformation *info, int fieldAssociation, const char *name)
| Remove the info associated with an array. More...
static vtkInformation * | SetActiveAttribute (vtkInformation *info, int fieldAssociation, const char *attributeName, int attributeType)
| Set the named array to be the active field for the specified type (SCALARS, VECTORS, NORMALS, TCOORDS, or TENSORS) and association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS). More...
static void | SetActiveAttributeInfo (vtkInformation *info, int fieldAssociation, int attributeType, const char *name, int arrayType, int numComponents, int numTuples)
| Set the name, array type, number of components, and number of tuples within the passed information object for the active attribute of type attributeType (in specified association, FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS). More...
static void | SetPointDataActiveScalarInfo (vtkInformation *info, int arrayType, int numComponents)
| Convenience version of previous method for use (primarily) by the Imaging filters. More...
static const char * | GetAssociationTypeAsString (int associationType)
| Given an integer association type, this static method returns a string type for the attribute (i.e. More...
static int | GetAssociationTypeFromString (const char *associationName)
| Given a string association name, this static method returns an integer association type for the attribute (i.e. More...
static vtkInformationStringKey * | DATA_TYPE_NAME ()
static vtkInformationDataObjectKey * | DATA_OBJECT ()
static vtkInformationIntegerKey * | DATA_EXTENT_TYPE ()
static vtkInformationIntegerPointerKey * | DATA_EXTENT ()
static vtkInformationIntegerVectorKey * | ALL_PIECES_EXTENT ()
static vtkInformationIntegerKey * | DATA_PIECE_NUMBER ()
static vtkInformationIntegerKey * | DATA_NUMBER_OF_PIECES ()
static vtkInformationIntegerKey * | DATA_NUMBER_OF_GHOST_LEVELS ()
static vtkInformationDoubleKey * | DATA_TIME_STEP ()
static vtkInformationInformationVectorKey * | POINT_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | CELL_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | VERTEX_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | EDGE_DATA_VECTOR ()
static vtkInformationIntegerKey * | FIELD_ARRAY_TYPE ()
static vtkInformationIntegerKey * | FIELD_ASSOCIATION ()
static vtkInformationIntegerKey * | FIELD_ATTRIBUTE_TYPE ()
static vtkInformationIntegerKey * | FIELD_ACTIVE_ATTRIBUTE ()
static vtkInformationIntegerKey * | FIELD_NUMBER_OF_COMPONENTS ()
static vtkInformationIntegerKey * | FIELD_NUMBER_OF_TUPLES ()
static vtkInformationIntegerKey * | FIELD_OPERATION ()
static vtkInformationDoubleVectorKey * | FIELD_RANGE ()
static vtkInformationIntegerVectorKey * | PIECE_EXTENT ()
static vtkInformationStringKey * | FIELD_NAME ()
static vtkInformationDoubleVectorKey * | ORIGIN ()
static vtkInformationDoubleVectorKey * | SPACING ()
static vtkInformationDoubleVectorKey * | DIRECTION ()
static vtkInformationDoubleVectorKey * | BOUNDING_BOX ()
static vtkInformationDataObjectKey * | SIL ()
static vtkDataObject * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkDataObject * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
static void | SetGlobalReleaseDataFlag (vtkTypeBool val)
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
static vtkTypeBool | GetGlobalReleaseDataFlag ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for type information and printing. More...
| vtkStructuredGrid ()
| ~vtkStructuredGrid () override
void | ComputeScalarRange () override
| Compute the range of the scalars and cache it into ScalarRange only if the cache became invalid (ScalarRangeComputeTime). More...
Protected Member Functions inherited from vtkPointSet
| vtkPointSet ()
| ~vtkPointSet () override
void | ReportReferences (vtkGarbageCollector *) override
Protected Member Functions inherited from vtkDataSet
| vtkDataSet ()
| ~vtkDataSet () override
Protected Member Functions inherited from vtkDataObject
| vtkDataObject ()
| ~vtkDataObject () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkVertex * | Vertex
vtkLine * | Line
vtkQuad * | Quad
vtkHexahedron * | Hexahedron
vtkEmptyCell * | EmptyCell
int | Dimensions [3]
int | DataDescription
int | Extent [6]
Protected Attributes inherited from vtkPointSet
bool | Editable
vtkPoints * | Points
vtkAbstractPointLocator * | PointLocator
vtkAbstractCellLocator * | CellLocator
Protected Attributes inherited from vtkDataSet
vtkCellData * | CellData
vtkPointData * | PointData
vtkCallbackCommand * | DataObserver
vtkTimeStamp | ComputeTime
double | Bounds [6]
double | Center [3]
double | ScalarRange [2]
vtkTimeStamp | ScalarRangeComputeTime
vtkUnsignedCharArray * | PointGhostArray
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
vtkUnsignedCharArray * | CellGhostArray
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
bool | PointGhostArrayCached
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
bool | CellGhostArrayCached
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
Protected Attributes inherited from vtkDataObject
vtkFieldData * | FieldData
vtkTypeBool | DataReleased
vtkTimeStamp | UpdateTime
vtkInformation * | Information
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

topologically regular array of data

vtkStructuredGrid is a data object that is a concrete implementation of vtkDataSet. vtkStructuredGrid represents a geometric structure that is a topologically regular array of points. The topology is that of a cube that has been subdivided into a regular array of smaller cubes. Each point/cell can be addressed with i-j-k indices. Examples include finite difference grids.

The order and number of points must match that specified by the dimensions of the grid. The point order increases in i fastest (from 0<=i<dims[0]), then j (0<=j<dims[1]), then k (0<=k<dims[2]) where dims[] are the dimensions of the grid in the i-j-k topological directions. The number of points is dims[0]*dims[1]*dims[2]. The same is true for the cells of the grid. The order and number of cells must match that specified by the dimensions of the grid. The cell order increases in i fastest (from 0<=i<(dims[0]-1)), then j (0<=j<(dims[1]-1)), then k (0<=k<(dims[2]-1)) The number of cells is (dims[0]-1)*(dims[1]-1)*(dims[2]-1).

vtkStructuredGrid has the ability to blank, or "turn-off" points and cells in the dataset. This is done by setting vtkDataSetAttributes::HIDDENPOINT or vtkDataSetAttributes::HIDDENCELL in the ghost array for each point / cell that needs to be blanked.

Examples:
  vtkStructuredGrid (Examples)

Online Examples:

Tests:
  vtkStructuredGrid (Tests)

Definition at line 62 of file vtkStructuredGrid.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPointSet vtkStructuredGrid::Superclass

Definition at line 68 of file vtkStructuredGrid.h.

## Constructor & Destructor Documentation

## ◆ vtkStructuredGrid()

vtkStructuredGrid::vtkStructuredGrid | ( |  | ) |
| protected

## ◆ ~vtkStructuredGrid()

vtkStructuredGrid::~vtkStructuredGrid | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkStructuredGrid* vtkStructuredGrid::New | ( |  | ) |
| static

## ◆ ExtendedNew()

static vtkStructuredGrid* vtkStructuredGrid::ExtendedNew | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkStructuredGrid::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkStructuredGrid::IsA | ( | const char * | type | ) |
| virtual

Standard methods for type information and printing.

Reimplemented from vtkPointSet.

## ◆ SafeDownCast()

static vtkStructuredGrid* vtkStructuredGrid::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkStructuredGrid::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for type information and printing.

Reimplemented from vtkPointSet.

## ◆ NewInstance()

vtkStructuredGrid* vtkStructuredGrid::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkStructuredGrid::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for type information and printing.

Reimplemented from vtkPointSet.

## ◆ GetDataObjectType()

int vtkStructuredGrid::GetDataObjectType | ( |  | ) |
| inlineoverridevirtual

Return what type of dataset this is.

Reimplemented from vtkPointSet.

Definition at line 74 of file vtkStructuredGrid.h.

## ◆ CopyStructure()

void vtkStructuredGrid::CopyStructure | ( | vtkDataSet * | ds | ) |
| overridevirtual

Copy the geometric and topological structure of an input poly data object.

Reimplemented from vtkPointSet.

## ◆ GetNumberOfPoints()

vtkIdType vtkStructuredGrid::GetNumberOfPoints | ( |  | ) |
| inlineoverridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

Definition at line 85 of file vtkStructuredGrid.h.

## ◆ GetPoint() [1/3]

double* vtkStructuredGrid::GetPoint | ( | vtkIdType | ptId | ) |
| inlineoverridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

Definition at line 86 of file vtkStructuredGrid.h.

## ◆ GetPoint() [2/3]

void vtkStructuredGrid::GetPoint | ( | vtkIdType | ptId,
|  | double | p[3]
| ) |  |
| inlineoverridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

Definition at line 90 of file vtkStructuredGrid.h.

## ◆ GetCell() [1/3]

vtkCell* vtkStructuredGrid::GetCell | ( | vtkIdType | cellId | ) |
| overridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

## ◆ GetCell() [2/3]

vtkCell* vtkStructuredGrid::GetCell | ( | int | i,
|  | int | j,
|  | int | k
| ) |  |
| override

Standard vtkDataSet API methods.

See vtkDataSet for more information.

## ◆ GetCell() [3/3]

void vtkStructuredGrid::GetCell | ( | vtkIdType | cellId,
|  | vtkGenericCell * | cell
| ) |  |
| overridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

## ◆ GetCellBounds()

void vtkStructuredGrid::GetCellBounds | ( | vtkIdType | cellId,
|  | double | bounds[6]
| ) |  |
| overridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkDataSet.

## ◆ GetCellType()

int vtkStructuredGrid::GetCellType | ( | vtkIdType | cellId | ) |
| overridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

## ◆ GetCellSize()

vtkIdType vtkStructuredGrid::GetCellSize | ( | vtkIdType | cellId | ) |
| overridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

## ◆ GetNumberOfCells()

vtkIdType vtkStructuredGrid::GetNumberOfCells | ( |  | ) |
| inlineoverridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

Definition at line 289 of file vtkStructuredGrid.h.

## ◆ GetCellPoints() [1/3]

void vtkStructuredGrid::GetCellPoints | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds
| ) |  |
| overridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

## ◆ GetPointCells()

void vtkStructuredGrid::GetPointCells | ( | vtkIdType | ptId,
|  | vtkIdList * | cellIds
| ) |  |
| inlineoverridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

Definition at line 100 of file vtkStructuredGrid.h.

## ◆ Initialize()

void vtkStructuredGrid::Initialize | ( |  | ) |
| overridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

## ◆ GetMaxCellSize()

int vtkStructuredGrid::GetMaxCellSize | ( |  | ) |
| inlineoverridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkPointSet.

Definition at line 107 of file vtkStructuredGrid.h.

## ◆ GetCellNeighbors() [1/2]

void vtkStructuredGrid::GetCellNeighbors | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds,
|  | vtkIdList * | cellIds
| ) |  |
| overridevirtual

Standard vtkDataSet API methods.

See vtkDataSet for more information.

Reimplemented from vtkDataSet.

## ◆ GetCellNeighbors() [2/2]

void vtkStructuredGrid::GetCellNeighbors | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds,
|  | vtkIdList * | cellIds,
|  | int * | seedLoc
| ) |  |

Standard vtkDataSet API methods.

See vtkDataSet for more information.

## ◆ SetDimensions() [1/2]

void vtkStructuredGrid::SetDimensions | ( | int | i,
|  | int | j,
|  | int | k
| ) |  |

Sets the extent to be 0 to i-1, 0 to j-1, and 0 to k-1.

## ◆ SetDimensions() [2/2]

void vtkStructuredGrid::SetDimensions | ( | const int | dims[3] | ) |

Sets the extent to be 0 to dim[i]-1 in all 3 dimensions.

## ◆ GetDimensions() [1/2]

virtual int* vtkStructuredGrid::GetDimensions | ( |  | ) |
| virtual

Get dimensions of this structured grid.

## ◆ GetDimensions() [2/2]

virtual void vtkStructuredGrid::GetDimensions | ( | int | dims[3] | ) |
| virtual

Get dimensions of this structured grid based on its extent.

## ◆ GetDataDimension()

int vtkStructuredGrid::GetDataDimension | ( |  | ) |
| inline

Return the dimensionality of the data.

Definition at line 311 of file vtkStructuredGrid.h.

## ◆ SetExtent() [1/2]

void vtkStructuredGrid::SetExtent | ( | VTK_FUTURE_CONST int | extent[6] | ) |

Different ways to set the extent of the data array.

The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

## ◆ SetExtent() [2/2]

void vtkStructuredGrid::SetExtent | ( | int | xMin,
|  | int | xMax,
|  | int | yMin,
|  | int | yMax,
|  | int | zMin,
|  | int | zMax
| ) |  |

Different ways to set the extent of the data array.

The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

## ◆ GetExtent() [1/3]

virtual int* vtkStructuredGrid::GetExtent | ( |  | ) |
| virtual

Different ways to set the extent of the data array.

The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

## ◆ GetExtent() [2/3]

virtual void vtkStructuredGrid::GetExtent | ( | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & |
| ) |  |
| virtual

Different ways to set the extent of the data array.

The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

## ◆ GetExtent() [3/3]

virtual void vtkStructuredGrid::GetExtent | ( | int | [6] | ) |
| virtual

Different ways to set the extent of the data array.

The extent should be set before the "Scalars" are set or allocated. The Extent is stored in the order (X, Y, Z).

## ◆ GetActualMemorySize()

unsigned long vtkStructuredGrid::GetActualMemorySize | ( |  | ) |
| overridevirtual

Return the actual size of the data in kibibytes (1024 bytes).

This number is valid only after the pipeline has updated. The memory size returned is guaranteed to be greater than or equal to the memory required to represent the data (e.g., extra space in arrays, etc. are not included in the return value). THIS METHOD IS THREAD SAFE.

Reimplemented from vtkPointSet.

## ◆ ShallowCopy()

void vtkStructuredGrid::ShallowCopy | ( | vtkDataObject * | src | ) |
| overridevirtual

Shallow and Deep copy.

Reimplemented from vtkPointSet.

## ◆ DeepCopy()

void vtkStructuredGrid::DeepCopy | ( | vtkDataObject * | src | ) |
| overridevirtual

Shallow and Deep copy.

Reimplemented from vtkPointSet.

## ◆ GetExtentType()

int vtkStructuredGrid::GetExtentType | ( |  | ) |
| inlineoverridevirtual

The extent type is a 3D extent.

Reimplemented from vtkDataObject.

Definition at line 174 of file vtkStructuredGrid.h.

## ◆ BlankPoint()

void vtkStructuredGrid::BlankPoint | ( | vtkIdType | ptId | ) |

Methods for supporting blanking of cells.

Blanking turns on or off points in the structured grid, and hence the cells connected to them. These methods should be called only after the dimensions of the grid are set.

## ◆ UnBlankPoint()

void vtkStructuredGrid::UnBlankPoint | ( | vtkIdType | ptId | ) |

Methods for supporting blanking of cells.

Blanking turns on or off points in the structured grid, and hence the cells connected to them. These methods should be called only after the dimensions of the grid are set.

## ◆ BlankCell()

void vtkStructuredGrid::BlankCell | ( | vtkIdType | ptId | ) |

Methods for supporting blanking of cells.

Blanking turns on or off cells in the structured grid, and hence the points connected to them. These methods should be called only after the dimensions of the grid are set.

## ◆ UnBlankCell()

void vtkStructuredGrid::UnBlankCell | ( | vtkIdType | ptId | ) |

Methods for supporting blanking of cells.

Blanking turns on or off cells in the structured grid, and hence the points connected to them. These methods should be called only after the dimensions of the grid are set.

## ◆ IsPointVisible()

unsigned char vtkStructuredGrid::IsPointVisible | ( | vtkIdType | ptId | ) |

Return non-zero value if specified point is visible.

These methods should be called only after the dimensions of the grid are set.

## ◆ IsCellVisible()

unsigned char vtkStructuredGrid::IsCellVisible | ( | vtkIdType | cellId | ) |

Return non-zero value if specified point is visible.

These methods should be called only after the dimensions of the grid are set.

## ◆ HasAnyBlankPoints()

bool vtkStructuredGrid::HasAnyBlankPoints | ( |  | ) |
| overridevirtual

Returns 1 if there is any visibility constraint on the points, 0 otherwise.

Reimplemented from vtkDataSet.

## ◆ HasAnyBlankCells()

bool vtkStructuredGrid::HasAnyBlankCells | ( |  | ) |
| overridevirtual

Returns 1 if there is any visibility constraint on the cells, 0 otherwise.

Reimplemented from vtkDataSet.

## ◆ GetCellDims()

void vtkStructuredGrid::GetCellDims | ( | int | cellDims[3] | ) |

Given the node dimensions of this grid instance, this method computes the node dimensions.

The value in each dimension can will have a lowest value of "1" such that computing the total number of cells can be achieved by simply by cellDims[0]*cellDims[1]*cellDims[2].

## ◆ Crop()

void vtkStructuredGrid::Crop | ( | const int * | updateExtent | ) |
| overridevirtual

Reallocates and copies to set the Extent to the UpdateExtent.

This is used internally when the exact extent is requested, and the source generated more than the update extent.

Reimplemented from vtkDataObject.

## ◆ GetData() [1/2]

static vtkStructuredGrid* vtkStructuredGrid::GetData | ( | vtkInformation * | info | ) |
| static

Retrieve an instance of this class from an information object.

## ◆ GetData() [2/2]

static vtkStructuredGrid* vtkStructuredGrid::GetData | ( | vtkInformationVector * | v,
|  | int | i = `0`
| ) |  |
| static

Retrieve an instance of this class from an information object.

## ◆ GetPoint() [3/3]

void vtkStructuredGrid::GetPoint | ( | int | i,
|  | int | j,
|  | int | k,
|  | double | p[3],
|  | bool | adjustForExtent = `true`
| ) |  |

Get a point in the grid.

If adjustForExtent is true, (i,j,k) is interpreted as a position relative to the beginning of the extent. If adjustForExtent is false, (i,j,k) is interpreted literally and the (i,j,k) point of the grid is returned regardless of the extent beginning. The point coordinate is returned in 'p'. The default adjustForExtent is true.

## ◆ ComputeScalarRange()

void vtkStructuredGrid::ComputeScalarRange | ( |  | ) |
| overrideprotectedvirtual

Compute the range of the scalars and cache it into ScalarRange only if the cache became invalid (ScalarRangeComputeTime).

Reimplemented from vtkDataSet.

## ◆ GetCellPoints() [2/3]

virtual void vtkDataSet::GetCellPoints

Topological inquiry to get points defining cell.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

## ◆ GetCellPoints() [3/3]

virtual void vtkDataSet::GetCellPoints

Topological inquiry to get points defining cell.

This function MAY use ptIds, which is an object that is created by each thread, to guarantee thread safety.

Warning
  Subsequent calls to this method may invalidate previous call results.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

## Member Data Documentation

## ◆ Vertex

vtkVertex* vtkStructuredGrid::Vertex
| protected

Definition at line 262 of file vtkStructuredGrid.h.

## ◆ Line

vtkLine* vtkStructuredGrid::Line
| protected

Definition at line 263 of file vtkStructuredGrid.h.

## ◆ Quad

vtkQuad* vtkStructuredGrid::Quad
| protected

Definition at line 264 of file vtkStructuredGrid.h.

## ◆ Hexahedron

vtkHexahedron* vtkStructuredGrid::Hexahedron
| protected

Definition at line 265 of file vtkStructuredGrid.h.

## ◆ EmptyCell

vtkEmptyCell* vtkStructuredGrid::EmptyCell
| protected

Definition at line 266 of file vtkStructuredGrid.h.

## ◆ Dimensions

int vtkStructuredGrid::Dimensions[3]
| protected

Definition at line 269 of file vtkStructuredGrid.h.

## ◆ DataDescription

int vtkStructuredGrid::DataDescription
| protected

Definition at line 271 of file vtkStructuredGrid.h.

## ◆ Extent

int vtkStructuredGrid::Extent[6]
| protected

Definition at line 273 of file vtkStructuredGrid.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkStructuredGrid.h